﻿//
// Copyright 2005 Elvis Mehmedovic.
// http://emehmedovic.com/
//

import xm.components.MenuComponent;
import xm.corpus.timeTrigger;

class xm.components.MenubarAnimator {
	
	var menu:MenuComponent;
	var startDelay:Number;
	var stepDelay:Number;
	var aChar:String;
	
	private var holder:MovieClip;
	
	private var __aniTrigger:timeTrigger;

	
	function MenubarAnimator(p_menu:MenuComponent, p_startdelay:Number, p_stepdelay:Number, p_achar:String) {
		menu = p_menu;
		startDelay = p_startdelay;
		stepDelay = p_stepdelay;
		aChar = p_achar;
		init();
	}
	
	private function _refreshItem(p_item:Number, p_length:Number, p_mask:Boolean) {
		
		var bg:MovieClip = holder[p_item];
		var tf:TextField = holder["l"+p_item];
		
		if (p_length == 1 && !bg._visible) {
			bg._visible = true;
			tf._visible = true;
		}
		if (p_mask) {
			tf.text = aChar.substr(0, p_length);
		}
		else {
			tf.text = menu.items[p_item].caption.substr(0, p_length) + aChar.substr(0, menu.items[p_item].caption.length-p_length);
		}
		
		bg.setSize(tf._width + menu.menuProperties.itemLeftMargin + menu.menuProperties.itemRightMargin, bg.height);
		
	}
	
	function doAnimate(Void):Void {
		
		free();
		
		var time:Number = startDelay;
		
		for (var i:Number = 0; i < menu.items.length; i++) {
			holder[i]._visible = false;
			holder["l"+i]._visible = false;
			
			if (aChar) {
				for (var j:Number = 1; j <= menu.items[i].caption.length; j++) {
					__aniTrigger.triggerAt(time, this, _refreshItem, [i, j, true]);
					time += stepDelay;
				}
			}
			for (var j:Number = 1; j <= menu.items[i].caption.length; j++) {
				__aniTrigger.triggerAt(time, this, _refreshItem, [i, j, false]);
				time += stepDelay;
			}
		}
		
	}
	
	function free() {
		__aniTrigger.free();
	}

	function init(Void):Void {
		
		__aniTrigger = new timeTrigger(30);
		holder = menu.holder;
		
		for (var i:Number = 0; i < 8; i++) {
			aChar += aChar;
		}
		
		doAnimate();
		
	}

}