﻿//
// Copyright 2005 Elvis Mehmedovic.
// http://emehmedovic.com/
//

class xm.components.MenuProperties {
	
	var vertical:Boolean;
	
	var customDimensions:Object;
	
	var leftMargin:Number = 0;
	var rightMargin:Number = 0;
	var topMargin:Number = 0;
	var bottomMargin:Number = 0;
	
	var itemLeftMargin:Number = 10;
	var itemRightMargin:Number = 10;
	var itemTopMargin:Number = 5;
	var itemBottomMargin:Number = 5;
	
	var textXOffsets:Array; 
	var textYOffsets:Array;
	
	var spawnDelay:Number = 200;
	
	var spawnOffsetX:Number = 0;
	var spawnOffsetY:Number = -1;
	
	var spawnSymbol:String = "Menu Component";
	var backgroundSymbol:String;
	var itemSymbol:String;
	var separatorSymbol:String;
	
	var separatorHeight:Number = 10;
	var separatorWidth:Number = 10;
	
	var shortcutSpace:Number = 20; 
	var iconSpace:Number = 0;
	var arrowSpace:Number = 10;
	
	var arrowOffsetX:Number = 0;
	var arrowOffsetY:Number = -1;
	
	var symbolOffsetX:Number = 0;
	var symbolOffsetY:Number = 0;
	
	var shortcutStrSpace:String = "";
	var iconStrSpace:String = "× ";
	
	var showShortcuts:Boolean = false;
	var showIcons:Boolean = false;
	var showArrow:Boolean = false;
	
	var forceTightFit:Boolean = false;
	var forcePulldownBehavior:Boolean = false;
	
	var itemSpacing:Number = 0;
	
	var textFormats:Array;
	var textFieldProperties:Object;
	
	function MenuProperties(p_initobj:Object) {
		textFieldProperties = new Object();
		
		textXOffsets = [0, 0, 0];
		textYOffsets = [0, 0, 0];
		
		if (p_initobj.vertical) {
			leftMargin =
			rightMargin =
			topMargin =
			bottomMargin = 5;
			itemLeftMargin =
			itemRightMargin = 5;
			itemTopMargin =
			itemBottomMargin = 2;
			showShortcuts = true;
			showIcons = true;
			showArrow = true;
			spawnOffsetX = -7;
			spawnOffsetY = -1;
		}
		if (p_initobj.vertical) {
			textFormats = [	
				new TextFormat("Verdana", 11, 0x333333), 
				new TextFormat("Verdana", 11, 0xFFFFFF), 
				null,
				new TextFormat("Verdana", 11, 0x888888)
			];
		}
		else {
			textFormats = [
				new TextFormat("Verdana", 11, 0x333333), 
				new TextFormat("Verdana", 11, 0x000000), 
				new TextFormat("Verdana", 11, 0x000000),
				new TextFormat("Verdana", 11, 0xAAAAAA)
			];
		}
		if (p_initobj) {
			for (var i:String in p_initobj) {
				this[i] = p_initobj[i];
			}
		}
	}

}