﻿//
// Copyright 2006 Elvis Mehmedovic.
// http://emehmedovic.com/
//

class xm.util.quickXML extends XML {
	
	var onXMLLoad:Function;

	private var url:String;
	private var _iid:Number;
	
	var preventCaching:Boolean = true;
	var retry:Boolean = true;
	var onError:Function;
	
	static var globalPreventXmlCaching:Boolean;
	static var globalVerboseXml:Boolean = false;

	function quickXML(p_url:String) {
		url = p_url;
		fetch();
	}
	
	function onData(p_raw:String) {
		if (p_raw) {
			if (p_raw.substr(0, 4) != "<xml") {
				trace("INVALID XML:")
				trace("-------------------------------------------");
				trace(p_raw);
				trace("-------------------------------------------");
				onError("Invalid XML");
			}
			else {
				if (globalVerboseXml) {
					trace("XML:");
					trace("-------------------------------------------");
					trace(p_raw.substr(0, 255));
					trace("-------------------------------------------");
				}
			}
		}
		return super.onData(p_raw);
	}
	
	private function fetch(Void):Void {
		
		if (globalVerboseXml) {
			trace("<- "+ url);
		}
		
		if (_iid != undefined) {
			clearInterval(_iid);
			delete _iid;
		}
		
		if (preventCaching && (url.substr(0, 7) == "http://" || !Boolean(_global.MMSave))) {
			if (url.indexOf("?") != -1) {
				load(url + "&rnd=" + random(9999) + "_" + random(9999));
			}
			else {
				load(url + "?rnd=" + random(9999) + "_" + random(9999));
			}
		}
		else {
			load(url);
		}
		
	}
	
	private function onLoad(p_success:Boolean):Void {
		
		if (!p_success) {
			trace("   ERROR LOADING XML")
			if (_global.MMSave) {
				trace("   Loading will not retry while testing in IDE.");
			}
			else {
				if (retry) {
					_iid = setInterval(fetch, 100);
				}
			}
			onError("Loading error");
		}
		else {
			onXMLLoad();
		}
		
	}
	
}